// pages/permissions/permissions.js
import { bindCar } from '../../api/permission'
const app = getApp()
Page({

  /**
   * 页面的初始数据
   */
  data: {
    scanFlag: true
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {
    console.log('permission show');
    if (!app.globalData.accessToken) {
      wx.showModal({
        content: '请先登录',
        confirmColor: '#333',
        showCancel: false,
        success (scanres) {
          if (scanres.confirm) {
            wx.redirectTo({
              url: '/pages/login/login'
            })
          }
        } 
      })
    }
  },

  bindscancode(e) {
    var that = this
    if (that.data.scanFlag) {
      var response = e.detail.result
      console.log(response, 'response');
      var scodeType = response.split('|')[0] == 'DEVICE' ? true : false
      if (!scodeType) {
        that.setData({
          scanFlag: false
        })
        wx.showModal({
          content: '请扫描正确的设备二维码',
          confirmColor: '#333',
          showCancel: false,
          success (scanres) {
            if (scanres.confirm) {
              that.setData({
                scanFlag: true
              })
            }
          } 
        })
      } else {
        // DEVICE|deviceCode|nonceCode|timeStamp
        var deviceCode = response.split('|')[1]
        var nonceCode = response.split('|')[2]
        var timeStamp = response.split('|')[3]
        that.bindCarFn(deviceCode, nonceCode, timeStamp)
      }
    }
  },

  bindCarFn (deviceCode = '', nonceCode = '', timeStamp = '') {
    var that = this
    var data = {
      deviceCode: deviceCode,
      nonceCode: nonceCode,
      timeStamp: timeStamp
    }
    wx.showLoading({
      title: '绑定中...',
      mask: true
    })
    bindCar(data).then(scanres => {
      that.setData({
        scanFlag: true
      })
      // 绑定成功到扫描档案页面
      wx.hideLoading()
      wx.showModal({
        content: '权限登录成功',
        confirmColor: '#333',
        showCancel: false,
        success (pres) {
          if (pres.confirm) {
            wx.navigateTo({
              url: '/pages/workbench/workbench?form=peimission&deviceName=' + scanres.data.deviceName + '&deviceCode=' + scanres.data.deviceCode
            })
          }
        }
      })
    }).catch(e => {
      that.setData({
        scanFlag: false
      })
      wx.hideLoading()
      wx.showModal({
        content: e.msg,
        confirmColor: '#333',
        showCancel: false,
        confirmText: '重新扫描',
        success (res) {
          if (res.confirm) {
            setTimeout(() => {
              that.setData({
                scanFlag: true
              })
            }, 400);
          }
        }
      })
    })
  },

  bindscanerror () {
    wx.showModal({
      content: '请打开相机权限',
      confirmColor: '#333',
      showCancel: false,
      success (auth) {
        if (auth.confirm) {
          wx.openSetting({
            success (res) {
              console.log(res.authSetting)
            }
          })
        }
      }
    })
  }
})